package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.pay.domain.PayAisle;
import com.zhongzheng.modules.pay.domain.PayNature;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PayPayeeAddBo;
import com.zhongzheng.modules.pay.bo.PayPayeeQueryBo;
import com.zhongzheng.modules.pay.bo.PayPayeeEditBo;
import com.zhongzheng.modules.pay.domain.PayPayee;
import com.zhongzheng.modules.pay.mapper.PayPayeeMapper;
import com.zhongzheng.modules.pay.vo.PayPayeeVo;
import com.zhongzheng.modules.pay.service.IPayPayeeService;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 收款方Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PayPayeeServiceImpl extends ServiceImpl<PayPayeeMapper, PayPayee> implements IPayPayeeService {

    @Override
    public PayPayeeVo queryById(Long payeeId){
        PayPayee db = this.baseMapper.selectById(payeeId);
        return BeanUtil.toBean(db, PayPayeeVo.class);
    }

    @Override
    public List<PayPayeeVo> queryList(PayPayeeQueryBo bo) {
        LambdaQueryWrapper<PayPayee> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getPayeeName()), PayPayee::getPayeeName, bo.getPayeeName());
        lqw.in(bo.getStatus() != null, PayPayee::getStatus, bo.getStatus());
        lqw.orderByDesc(PayPayee::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PayPayeeVo> entity2Vo(Collection<PayPayee> collection) {
        List<PayPayeeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PayPayeeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PayPayee> page = (Page<PayPayee>)collection;
            Page<PayPayeeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PayPayeeAddBo bo) {
        PayPayee add = BeanUtil.toBean(bo, PayPayee.class);
        LambdaQueryWrapper<PayPayee> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getPayeeName()), PayPayee::getPayeeName, bo.getPayeeName());
        List<Integer> status = new ArrayList<>();
        status.add(1);
        status.add(0);
        lqw.in(bo.getStatus() != null, PayPayee::getStatus, status);
        List<PayPayee> list = this.list(lqw);
        if (CollectionUtils.isNotEmpty(list)){
            throw new RuntimeException("重复收款方名字");
        }
            validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PayPayeeEditBo bo) {
        PayPayee update = BeanUtil.toBean(bo, PayPayee.class);
        LambdaQueryWrapper<PayPayee> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getPayeeName()), PayPayee::getPayeeName, bo.getPayeeName());
        lqw.like(bo.getPayeeId()!= null, PayPayee::getPayeeId, bo.getPayeeId());
        List<PayPayee> list = this.list(lqw);
        if (CollectionUtils.isEmpty(list)){
            lqw.clear();
            lqw.eq(StrUtil.isNotBlank(bo.getPayeeName()), PayPayee::getPayeeName, bo.getPayeeName());
            List<Integer> status = new ArrayList<>();
            status.add(1);
            status.add(0);
            lqw.in(bo.getStatus() != null, PayPayee::getStatus, status);
            List<PayPayee> list1 = this.list(lqw);
            if (CollectionUtils.isNotEmpty(list1)){
                throw new IllegalArgumentException("重复收费性质名字");
            }
        }
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PayPayee entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
